From af2aba146ae211ec36c8cdd21bef2f9b55321f3c Mon Sep 17 00:00:00 2001
From: Adam Samalik <asamalik@redhat.com>
Date: May 14 2020 09:21:35 +0000
Subject: [PATCH 34/88] separate the english and the translated builds


---

diff --git a/build-scripts/Dockerfile b/build-scripts/Dockerfile
index 6a09f2b..a20ccc6 100644
--- a/build-scripts/Dockerfile
+++ b/build-scripts/Dockerfile
@@ -6,8 +6,8 @@ RUN dnf -y module install nodejs:10/default && \
 
 RUN npm i -g @antora/cli@2.0 @antora/site-generator-default@2.0
 
-ADD build-translated.py /antora/build-translated.py
+ADD rebuild-site.py /antora/rebuild-site.py
 
 WORKDIR /antora
 
-CMD /antora/build-translated.py
+CMD /antora/rebuild-site.py
diff --git a/build-scripts/rebuild-site.py b/build-scripts/rebuild-site.py
new file mode 100755
index 0000000..7755326
--- /dev/null
+++ b/build-scripts/rebuild-site.py
@@ -0,0 +1,383 @@
+#!/usr/bin/python3
+
+
+# The script requires the following environment variables to be set:
+# 
+# Variable          Values      Effect
+# -----------------|-----------------------------------------------------------
+# BUILD_ENV         prod        Build the production version of the site
+#                               using the "prod" branch. DEFAULT
+#                   stg         Build the staging version of the site
+#                               using the "stg" branch.
+# -----------------|-----------------------------------------------------------
+# BUILD_LANGS       english     Build the "en-US" version only. DEFAULT
+#                   translated  Build only the translated versions.
+#                   all         Build the "en-US" and the translated versions.
+#
+#
+
+
+import tempfile, yaml, os, errno, subprocess, copy, datetime, shutil, sys
+
+
+def get_config():
+    config = {}
+
+    config["docs_repo_branch"] = os.getenv(
+        "BUILD_ENV",
+        "prod")
+
+    config["build_langs"] = os.getenv(
+        "BUILD_LANGS",
+        "english")
+
+    config["docs_repo_url"] = os.getenv(
+        "DOCS_REPO_URL",
+        "https://pagure.io/fedora-docs/docs-fp-o.git")
+
+    config["translated_sources_repo_url"] = os.getenv(
+        "TRANSLATED_SOURCES_REPO_URL",
+        "https://pagure.io/fedora-docs/translated-sources.git"
+    )
+    
+    return config
+
+
+def log(msg):
+    print(msg)
+
+
+def get_languages(config):
+    languages_dict = {}
+
+    with tempfile.TemporaryDirectory() as workdir:
+        translated_sources_repo = os.path.join(workdir, "translated_sources_repo")
+        subprocess.run(["git", "clone", config["translated_sources_repo_url"], translated_sources_repo])
+
+        languages = []
+        filename_blacklist = [".git"]
+        for filename in os.listdir(translated_sources_repo):
+            filepath = os.path.join(translated_sources_repo, filename)
+            if os.path.isdir(filepath) and filename not in filename_blacklist:
+                languages.append(filename)
+
+        languages.sort()
+
+        for lang in languages:
+            languages_dict[lang] = []
+
+            lang_dir = os.path.join(translated_sources_repo, lang)
+            for component in os.listdir(lang_dir):
+                version_dir = os.path.join(lang_dir, component)
+                for version in os.listdir(version_dir):
+                    start_path = "{lang}/{component}/{version}".format(
+                            lang=lang, component=component, version=version)
+
+                    # This is a workaround for cases when a component doesn't have
+                    # the ROOT module that should contain the antora.yml.
+                    # Without the ROOT module the translation scripts won't
+                    # pick up the antora.yml causing the docs build to fail.
+                    # So we're only including directories with the antora.yml file.
+                    if "antora.yml" in os.listdir(os.path.join(version_dir, version)):
+                        languages_dict[lang].append(start_path)
+
+    return languages_dict
+
+
+def generate_lang_switch_ui(languages):
+    template_start = """
+        <div class="page-languages">
+            <button class="languages-menu-toggle" title="Show other languages of the site">
+                {{{env.ANTORA_LANGUAGE}}}
+            </button>
+            <div class="languages-menu">
+    """
+    template_end = """
+            </div>
+        </div>
+    """
+
+    template_list = []
+    template_list.append(template_start)
+    for language in languages:
+        link = '<a class="language" href="{{{{siteRootPath}}}}/../{language}{{{{page.url}}}}">{language}</a>'.format(
+                    language=language)
+        template_list.append(link)
+    template_list.append(template_end)
+
+    return "\n".join(template_list)
+
+def prepare_translated_sources(translated_sources, site_yml, languages, config):
+    with tempfile.TemporaryDirectory() as workdir:
+        # Location of the translated-sources repo
+        #   (This repo only holds content that has some translations done,
+        #   so it might be incomplete.)
+        translated_sources_original = os.path.join(workdir, "translated_sources_original")
+
+        # Location of the English sources in the same structure
+        # as translated-sources, so:
+        #    COMPONENT/VERSION/antora.yml
+        #    COMPONENT/VERSION/modules/MODULE1
+        #    COMPONENT/VERSION/modules/MODULE2
+        #    COMPONENT/VERSION/modules/...
+        en_sources = os.path.join(workdir, "en_sources")
+
+        # Clone the original translated-sources
+        subprocess.run(["git", "clone", config["translated_sources_repo_url"], translated_sources_original])
+
+        # Get a list of the original English repos
+        repos = []
+        for repo_data in site_yml["content"]["sources"]:
+
+            if "branches" not in repo_data:
+                repo_data["branches"] = ["master"]
+            if "start_path" not in repo_data:
+                repo_data["start_path"] = ""
+
+            for branch in repo_data["branches"]:
+                repo = {}
+                repo["url"] = repo_data["url"]
+                repo["branch"] = branch
+                repo["start_path"] = repo_data["start_path"]
+
+                repos.append(repo)
+        
+        # Clome the original English sources and put them into the
+        # desired structure in en_sources (described above)
+        components = {}
+        for repo in repos:
+            with tempfile.TemporaryDirectory() as tmp_repo_root:
+                log("")
+                log("Cloning {url} {branch}".format(url=repo["url"], branch=repo["branch"]))
+                subprocess.run(["git", "clone", "--branch", repo["branch"], repo["url"], tmp_repo_root])
+
+                repo_dir = os.path.join(tmp_repo_root, repo["start_path"])
+                antora_yml_file = os.path.join(repo_dir, "antora.yml")
+                with open(antora_yml_file, "r") as file:
+                    antora_yml = yaml.safe_load(file)
+
+                component = antora_yml["name"]
+                version = antora_yml["version"]
+
+                # Saving components and all their versions
+                if component not in components:
+                    components[component] = set()
+                components[component].add(version)
+
+                for module in os.listdir(os.path.join(repo_dir, "modules")):
+                    # Now this is looping over modules accross all components,
+                    # so component, module, and version variables are available
+
+                    try:
+                        os.makedirs(os.path.join(en_sources, component, version, "modules"))
+                    except OSError as e:
+                        if e.errno != errno.EEXIST:
+                            raise
+                    
+                    original_module_dir = os.path.join(repo_dir, "modules", module)
+                    module_dir = os.path.join(en_sources, component, version, "modules", module)
+
+                    subprocess.run(["cp", "-r", original_module_dir, module_dir])
+
+                    if module == "ROOT" or "nav" in antora_yml:
+                        # if this is the main antora.yml file
+                        subprocess.run(["cp", "-r", antora_yml_file, os.path.join(en_sources, component, version, "antora.yml")])
+                        log("----- copying antora.yml for  {component} {module} {version}".format(
+                                component=component, module=module, version=version))
+                    else:
+                        log("----- skipping antora.yml for  {component} {module} {version}".format(
+                                component=component, module=module, version=version))
+
+        # Set up the language structure in translated_sources
+        for language in languages:
+            lang_dir = os.path.join(translated_sources, language)
+            try:
+                os.makedirs(lang_dir)
+            except OSError as e:
+                if e.errno != errno.EEXIST:
+                    raise
+        
+        # Copy the English sources in the translated_sources
+        for language in languages:
+            lang_dir = os.path.join(translated_sources, language)
+            for component in components:
+                en_component_dir = os.path.join(en_sources, component)
+                subprocess.run(["cp", "-r", en_component_dir, lang_dir])
+
+        # And finally copy the original translated sources
+        # into translated_sources
+        for language in languages:
+            src = os.path.join(translated_sources_original, language)
+            subprocess.run(["cp", "-r", src, translated_sources + "/"])
+
+    return components
+
+
+def init_git_repo(path):
+    try:
+        os.makedirs(path)
+    except OSError as e:
+        if e.errno != errno.EEXIST:
+            raise
+    subprocess.run(["git", "init"], cwd=path)
+    subprocess.run(["git", "config", "user.name", "Your Name"], cwd=path)
+    subprocess.run(["git", "config", "user.email", "you@example.com"], cwd=path)
+    subprocess.run(["git", "commit", "--allow-empty", "-m", "init"], cwd=path)
+
+
+def main():
+    config = get_config()
+    
+    with tempfile.TemporaryDirectory() as workdir:
+
+        #####--------------------------------------#####
+        #####  Preparation                         #####
+        #####--------------------------------------#####
+
+        # Location of the docs-fp-o repo
+        docs_repo = os.path.join(workdir, "docs_repo")
+
+        # Location of the translated sources used for the build
+        #   (That's the translated-sources repo with the missing files added
+        #   from the English sources.)
+        translated_sources = os.path.join(workdir, "translated_sources")
+        init_git_repo(translated_sources)
+
+        log("")
+        log("===== Getting the site definition (site.yml) =====")
+        subprocess.run(["git", "clone", "--branch", config["docs_repo_branch"], config["docs_repo_url"], docs_repo])
+
+        with open(os.path.join(docs_repo, "site.yml"), "r") as file:
+            original_site_yml = yaml.safe_load(file)
+
+        log("")
+        log("===== Getting a list of languages =====")
+        languages = get_languages(config)
+        log("  Languages: {}".format(" ".join(languages)))
+
+        log("")
+        log("===== Generating the language switch UI =====")
+        lang_switch_ui = generate_lang_switch_ui(["en-US"] + list(languages.keys()))
+
+        ui_dir = os.path.join(docs_repo, "supplemental-ui", "partials")
+        try:
+            os.makedirs(ui_dir)
+        except OSError as e:
+            if e.errno != errno.EEXIST:
+                raise
+
+        ui_file = os.path.join(ui_dir, "page-languages.hbs")
+        with open(ui_file, "w") as file:
+            file.write(lang_switch_ui)
+
+        # Timestamp to be included in the footer of the docs
+        timestamp = datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S UTC')
+        antora_env = copy.deepcopy(os.environ)
+        antora_env["ANTORA_DATE"] = timestamp
+
+
+
+        #####--------------------------------------#####
+        #####  English site build                  #####
+        #####--------------------------------------#####
+
+        if config["build_langs"] == "english" or config["build_langs"] == "all":
+
+            log("")
+            log("===== Building the en-US site =====")
+            antora_env["ANTORA_LANGUAGE"] = "en-US"
+            result = subprocess.run(["antora", "--html-url-extension-style=indexify", os.path.join(docs_repo, "site.yml")], env=antora_env)
+
+            if result.returncode != 0:
+                log("ERROR building the en-US site")
+                sys.exit(1)
+                
+            log("")
+            log("===== Copying the en-US site =====")
+            source_dir = os.path.join(docs_repo, "public")
+            target_dir_copying = "/antora/output/en-US.building"
+            target_dir_copied = "/antora/output/en-US.building/en-US"
+            target_dir_final = "/antora/output/en-US"
+            shutil.rmtree(target_dir_copying, ignore_errors=True)
+            subprocess.run(["cp", "-r", source_dir, target_dir_copying])
+            shutil.rmtree(target_dir_final, ignore_errors=True)
+            shutil.move(target_dir_copied, target_dir_final)
+            shutil.rmtree(target_dir_copying, ignore_errors=True)
+
+            log("")
+            log("===== Copying the index.html =====")
+            source_index_html = os.path.join(docs_repo, "static", "index.html")
+            target_index_html = "/antora/output/index.html"
+            shutil.copy(source_index_html, target_index_html)
+
+
+
+        #####--------------------------------------#####
+        #####  Translated site build               #####
+        #####--------------------------------------#####
+
+        if config["build_langs"] == "translated" or config["build_langs"] == "all":
+
+            log("")
+            log("===== Preparing the translated sources =====")
+            components = prepare_translated_sources(translated_sources, original_site_yml, languages, config)
+
+            log("")
+            log("===== Generating site.lang.yml files =====")
+            for lang in languages:
+                lang_site_yml = copy.deepcopy(original_site_yml)
+
+                lang_site_yml["output"]["dir"] = "./public/{lang}".format(lang=lang)
+
+                lang_site_yml["content"] = {}
+                # Branches are set to HEAD because the script uses a locally-generated
+                # content on top of the original translated-sources repo
+                lang_site_yml["content"]["branches"] = "HEAD"
+                lang_site_yml["content"]["sources"] = []
+
+                for component, versions in components.items():
+                    for version in versions:
+                        source = {}
+                        source["url"] = translated_sources
+                        source["start_path"] = "{lang}/{component}/{version}".format(
+                                    lang=lang, component=component, version=version)
+
+                        lang_site_yml["content"]["sources"].append(source)
+
+                filename = os.path.join(docs_repo, "site-{lang}.yml".format(lang=lang))
+                with open(filename, "w") as file:
+                    file.write(yaml.dump(lang_site_yml))
+
+                log("  {lang} done".format(lang=lang))
+
+            # Building all the translated sites
+            for lang in languages:
+                log("")
+                log("===== Building the {lang} site =====".format(lang=lang))
+                filename = "site-{lang}.yml".format(lang=lang)
+                antora_env["ANTORA_LANGUAGE"] = lang
+                result = subprocess.run(["antora", "--html-url-extension-style=indexify", os.path.join(docs_repo, filename)], env=antora_env)
+
+                if result.returncode != 0:
+                    log("ERROR building the {lang} site".format(lang=lang))
+                    sys.exit(1)
+
+            # Copying all the translated sites
+            for lang in languages:
+                log("")
+                log("===== Copying the {lang} site =====".format(lang=lang))
+                source_dir = os.path.join(docs_repo, "public")
+                target_dir_copying = "/antora/output/{lang}.building".format(lang=lang)
+                target_dir_copied = "/antora/output/{lang}.building/{lang}".format(lang=lang)
+                target_dir_final = "/antora/output/{lang}".format(lang=lang)
+                shutil.rmtree(target_dir_copying, ignore_errors=True)
+                subprocess.run(["cp", "-r", source_dir, target_dir_copying])
+                shutil.rmtree(target_dir_final, ignore_errors=True)
+                shutil.move(target_dir_copied, target_dir_final)
+                shutil.rmtree(target_dir_copying, ignore_errors=True)
+    
+
+
+if __name__ == "__main__":
+    main()
+

